<!DOCTYPE html>
<html>

<head>
    <title>Lucky Dice Casino</title>
    <meta charset='utf-8'>
    <meta name='viewport' content='width=device-width, initial-scale=1'>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- class CSS để dùng trong bài -->
    <style>
        .picture-cover { 
            background-image: url("LuckyDiceImages/cover.jpg");
            min-height: 100px;
            margin: 5px;
        }
    </style>
</head>

<body>
    <div class="container-fluid  picture-cover">
        
    </div>
    <div class="container ">
        <div class="row ">
            <div class="col-5 bg-white  ">
                <div class="row  form-group">
                    <div class="col-12"> <!-- Tại dòng 2.1.1.1 thêm một div column rộng 12 đơn vị -->
                        <h4>Nhập thông tin của bạn</h4>
                    </div>
                </div>
                <div class="row   form-group"> <!-- tại mỗi dòng 2.1.1.2 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  "> <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Username</label>
                    </div>
                    <div class="col-8  "> <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-user-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row   form-group"> <!-- tại mỗi dòng 2.1.1.3 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  ">  <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Firstname</label>
                    </div>
                    <div class="col-8  ">  <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-first-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row   form-group"><!-- tại mỗi dòng 2.1.1.4 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  ">  <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Lastname</label>
                    </div>
                    <div class="col-8  "> <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-last-name" class="form-control" type="text">
                    </div>
                </div>
            </div>
            <div class="col-4  text-center"> <!-- Tại cột 2.1.2 tạo 3 div class row, cột 2.1.2 có thuộc tính căn giữa -->
               <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <input id="btn-dice" class="btn btn-success button-width w-75" value="Ném" type="button">
                    </div>
               </div>
               <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị-->
                        <img id="img-dice" class="img-thumbnail" src="LuckyDiceImages/dice.png">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <p id="p-notification-dice">Chúc mừng</p>
                    </div>
                </div>
            </div>
            <div class="col-3  text-center"> <!-- Tại cột 2.1.3 tạo 2 div class row, cột 2.1.3 có thuộc tính căn giữa -->
                <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <p>Voucher</p>
                        <p id="p-voucher-id">No ID</p>
                        <p id="p-voucher-percent">0%</p>
                    </div>
               </div>
               <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị-->
                        <img id="img-present" class="img-thumbnail" src="LuckyDiceImages/motobike.jpg">
                    </div>
                </div>
            </div>
        </div>
        <div class="row  text-center form-group"> <!-- Tại row 2.2 thêm một div column rộng 12 đơn vị  -->
            <div class="col-12">
                <button id="btn-dice-history" class="btn btn-info button-width w-25">Dice History</button>
                <button id="btn-voucher-history" class="btn btn-success button-width w-25">Voucher History</button>
                <button id="btn-present-history" class="btn btn-success button-width w-25">Present History</button>
            </div>
        </div>
        <div class="row "> <!-- Tại row 2.3 thêm một div column rộng 12 đơn vị  -->
            <div class="col-12">
                <table id="history-placeholder-table" class="table table-striped table-hover ">
                    <tr>
                        <th>Lượt</th>
                        <th>Dice</th>
                    </tr>
                    <tr>
                        <td>1</td>
                        <td>2</td>
                    </tr>
                    <tr>
                        <td>2</td>
                        <td>6</td>
                    </tr>
                    <tr>
                        <td>3</td>
                        <td>4</td>
                    </tr>
                    <tr>
                        <td>4</td>
                        <td>5</td>
                    </tr>
                    <tr>
                        <td>5</td>
                        <td>4</td>
                    </tr>
                </table>
            </div>
        </div>
    </div>
</body>
<script>
 //REGION 1:
 const gREQUEST_READYSTATE_FINISH_RESPONSE_READY = 4;
 const gREQUEST_STATUS_OK = 200;
 const vBaseUrl = "http://42.115.221.44:8080/devcamp-lucky-dice/";
 const vUtf8TextApplicationHeader = "application/json;charset=UTF-8";
 //REGION 2:
 $(document).ready(function(){
     $("#btn-dice").click(onBtnNewDiceClick);
 })
 //REGION 3:
 
    var gInpUser = $("#inp-user-name");
    var gInpFirstName = $("#inp-first-name");
    var gInpLastName = $("#inp-last-name");


 function onBtnNewDiceClick(){
 "use strict";
  //B0:khai báo dữ liệu:
  var vUserObj = {
      usename: "",
      firstname: "",
      lastname: ""
  }  
  //B1:thu thập dữ liệu
  getData(vUserObj);
  //B2:validateData
  var vIsCheck = validateData(vUserObj);
  if(vIsCheck){
  //B3:call API to getNewDice
  var vXmlHttpNewDice = new XMLHttpRequest();
  callApiToGetNewDice(vXmlHttpNewDice,vUserObj);
  vXmlHttpNewDice.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READYSTATE_FINISH_RESPONSE_READY
                    && this.status == gREQUEST_STATUS_OK) {  //nếu trạng thái của response ready và ok
                    // console.log(vXmlHttpDice.responseText);
                    showResultNewDice(vXmlHttpNewDice);
                }
            }  
  }
 }
 //REGION 4:
 function getData(paramUserObj){
    "use strict";

    var vValueUser = $.trim(gInpUser.val());
    var vValueFirstName = $.trim(gInpFirstName.val());
    var vValueLastName = $.trim(gInpLastName.val());

    paramUserObj.usename = vValueUser;
    paramUserObj.firstname = vValueFirstName;
    paramUserObj.lastname = vValueLastName;

 }

 function validateData(paramUserObj){
    if(paramUserObj.usename === ""){
        alert("chưa điền username");
        return false;
    }
    if(paramUserObj.firstname === ""){
        alert("chưa điền firstname");
        return false;
    }
    if(paramUserObj.lastname === ""){
        alert("chưa điền lastname");
        return false;
    }
    return true;
 }

 //call API
 function callApiToGetNewDice(paramXmlHttpNewDice,paramUserObj){
    paramXmlHttpNewDice.open("POST", vBaseUrl + "/dice", true);
    paramXmlHttpNewDice.setRequestHeader("Content-Type", vUtf8TextApplicationHeader);
    paramXmlHttpNewDice.send(JSON.stringify(paramUserObj));  //chuyển Json object sang string 
 }

 function showResultNewDice(paramXmlHttpNewDice){
    "use strict";
    console.log(paramXmlHttpNewDice.responseText);
    //change JSON data type form string to object
    var vResponse = JSON.parse(paramXmlHttpNewDice.responseText);

    var vNewDice = vResponse.dice;
    //hiển thị NewDice mới
    showNewDiceDisplay(vNewDice);
    //hiển thị NewDice message
    showNewDiceMessage(vNewDice);
    //hiển thị voucher
    showNewDiceVoucher(vResponse);
    //hiển thị prize
    showNewDicePrize(vResponse);
 }

 function showNewDiceDisplay(paramNewDice){
    "use strict";
    switch(paramNewDice){
        case 1:
            $("#img-dice").prop("src", "LuckyDiceImages/1.png")
            break;
        case 2:
            $("#img-dice").prop("src", "LuckyDiceImages/2.png")
        break;
        case 3:
            $("#img-dice").prop("src", "LuckyDiceImages/3.png")
        break;
        case 4:
            $("#img-dice").prop("src", "LuckyDiceImages/4.png")
        break;
        case 5:
            $("#img-dice").prop("src", "LuckyDiceImages/5.png")
        default:
            $("#img-dice").prop("src", "LuckyDiceImages/6.png")
    }   
 }

 function showNewDiceMessage(paramNewDice){

    if(paramNewDice < 4){
        $("#p-notification-dice").html("Chúc bạn may mắn lần sau!!!");
    } else{
        $("#p-notification-dice").html("Chúc bạn đã đạt được thành tích cao!!!");
    }
 }

 function showNewDiceVoucher(paramResponse){
    "use strict";
    if(paramResponse.voucher != null){
        $("#p-voucher-id").html(paramResponse.voucher.maVoucher);
        $("#p-voucher-percent").html(paramResponse.voucher.phanTramGiamGia + "%");
    }
    else{
        $("#p-voucher-id").html("");
        $("#p-voucher-percent").html("");
    }
 }

 function showNewDicePrize(paramResponse){
    "use strict";
    switch(paramResponse.prize){
        case "Mũ":
            $("#img-present").prop("src","LuckyDiceImages/hat.jpg");
        break;
        case "Áo":
            $("#img-present").prop("src","LuckyDiceImages/t-shirt.jpg");
        break;
        case "Xe máy":
            $("#img-present").prop("src","LuckyDiceImages/motobike.jpg"); 
        break;
        case "Ổ tô":
            $("#img-present").prop("src","LuckyDiceImages/car.jpg");
        break;
        default:
            $("#img-present").prop("src","LuckyDiceImages/no-present.jpg");           
    }
 }
</script>


</html>